
        page    63,131
	Title	VESA Device Chain Stub
	Subttl	Copyright (c) 1994  V.E.S.A, Inc. All Rights Reserved.

;   /*\
;---|*|------------------------====< MAIN.ASM >====---------------------------
;---|*|
;---|*| Copyright (c) 1994  V.E.S.A, Inc. All Rights Reserved.
;---|*|
;---|*| VBE/AI 1.0 Specification
;---|*|    February 3, 1994. 1.00 release
;---|*|
;   \*/

        .286
        .model  small,c
	.code
	assume	ds:@code, es:@code

	include vbeai.inc


;   /*\
;---|*|------------------====< Start of Execution >====------------------------
;   \*/

	org	100h			; a .COM program

StartHere       label   near

	jmp	startup

;
; This is the INT 10h entrypoint for handling the chain.
;

entrypoint      label   near

        cmp     ax,VESAFUNCID           ; a VBE/AI function?
	jz	@F			; yes, go do it...
	jmp    dword ptr cs:[int10chain]; move on...
    ;
    @@:

        cmp     bl,VESAFUNC0            ; ID check?
	jnz	@F			; no, continue on...

;;;;;;; int 3

	mov	bx,VBEAI_VERSION	; bx returns the BCD version #
        clc                             ; returning successful
	jmp	returnhome		; with the version in BX
    ;
    @@:
	cmp	bl,VESAFUNC6		; function #6 - Remove?
	jnz	chainondude		; no, continue on...

;;;;;;;;int 3

	cmp	bh,0			; link in request
	jnz	ouin40a 		; no, go unlink

	cli				; yes, swap in the new vector

	xchg	cx,wptr cs:[chainto+0]	; swap the 32 bit vector
	xchg	dx,wptr cs:[chainto+2]

	sti

        clc                             ; returning successful
	jmp	returnhome

    ;
    ouin40a:
        cmp     wptr cs:[chainto+0],cx  ; matching chain?
	jnz	chainondude		; no, keep searching...
	cmp	wptr cs:[chainto+2],dx	; matching chain?
	jnz	chainondude		; no, keep searching...

        cli                             ; make sure we don't cause problems

	mov	wptr cs:[chainto+0],di	; replace the dying drivers address
	mov	wptr cs:[chainto+2],si	; with a more current address

	sti

        clc                             ; returning successful
;
returnhome:
	mov	ax,004Fh		; VESA protocol status returned in AX
	adc	ah,0			; carry indicates problems
	iret				; go home...
;
chainondude:
	cmp	wptr cs:[chainto+2],0	; valid chain?
	jz	returnhome		; no, this is the end of the chain
	jmp	dptr cs:[chainto]	; move on to the next VBE/AI driver

int10chain	dd	0		; regular INT 10 chain
chainto 	dd	0		; VBE/AI chain

		db	0		; add padding to the length
lastbyte	label	near

;   /*\
;---|*|---------------------====< Throwaway Code >====-------------------------
;   \*/
		     
startup:

;
; print the banner message
;
	lea	dx,msg01
	mov	ah,09h
	int	21h
;
; see if there are devices present
;
	mov	ax,VESAFUNCID
	mov	bx,VESAFUNC0
	sub	cx,cx
	sub	di,di
	mov	es,di

        int     10h

	cmp	bl,VESAFUNC0
	jz	nodevices	; nothing loaded, we can stay

	lea	dx,msg02	; tell the world we're not needed
	mov	ah,09h
	int	21h

	mov	ax,4c00h	; exit for good
	int	21h
;
nodevices:
	mov	ax,3510h	; get the old vector
	int	21h
	mov	word ptr cs:[int10chain+0],bx
	mov	word ptr cs:[int10chain+2],es

	lea	dx,entrypoint
	push	cs
	pop	ds
	mov	ax,2510h	; set the new vector
	int	21h

	lea	dx,msg03	; tell the world we're now resident
	mov	ah,09h
	int	21h

	lea	dx,lastbyte	; go resident..
	int	27h

msg01	db	0Dh,0Ah,'VBE/AI device chain stub TSR, v1.00',0Dh,0Ah,'$'

msg02	db	'VBE/AI drivers are present, stub not staying resident',0Dh,0Ah,'$'

msg03	db	'stub now resident',0Dh,0Ah,'$'

;   /*\
;---|*| end of main.asm
;   \*/

	end	StartHere


